/// <reference types="node" />
import * as http from 'http';
import * as https from 'https';
export declare type ServiceStartFunc = {
    (): (Promise<void> | Promise<boolean>);
};
export declare type ServiceListenFunc = {
    (webServer: http.Server | https.Server): Promise<void>;
};
export declare type ServiceStopFunc = {
    (): Promise<void>;
};
export interface ServiceT {
    start: ServiceStartFunc;
    listen?: ServiceListenFunc;
    stop?: ServiceStopFunc;
}
